#===istalismanplugin===
# -*- coding: utf-8 -*-

#  Talisman plugin
#  trans_plugin.py

# (C) Gigabyte
# Сайт:   http://www.bots.ucoz.ru/
#         http://www.jabbrik.ru/
# Конфа:  stalker@conference.jabbers.ru
# e-mail: gigabyte@ngs.ru
	
import urllib
import httplib
import re
from string import replace

def google_translate(from_lang, to_lang, text):
	params = urllib.urlencode({"langpair":"%s|%s" %(from_lang, to_lang), "text":text,"ie":"UTF8", "oe":"UTF8"})
	conn = httplib.HTTPConnection("translate.google.com")
	conn.request("POST", "/translate_t", params)

	resp = conn.getresponse()
	s = resp.read()
	conn.close()

	match = re.compile('<div id=result_box.*?>(.*?)</div>',re.DOTALL).search(s)
	data = match.groups()[0]
	return unicode(data, "utf-8").strip()
	
	
def handler_google_trans(type,source,parameters):
	if parameters.strip()==u'языки':
		if type == 'public':
			reply(type,source,u'ушли')
		reply('private',source,u'английский – французский (ef)\n\
английский – немецкий (ed)\n\
английский – итальянский (ei)\n\
английский – корейский (ek)\n\
английский – японский (ej)\n\
английский – русский (er)\n\
русский – английский (re)\n\
английский – испанский (es)\n\
английский – португальский (ep)\n\
немецкий – французский (df)\n')
		return
	stsp=string.split(parameters, ' ', 1)
	if not len(stsp)>=2:
		reply(type,source,u'чего-то не хватает, прочти хелп')
	langpairs={'er': 'en ru', 're': 'ru en','ef': 'en fr','ed': 'en de', 'df': 'de fr','ei': 'en it', 'es': 'en sp', 'ep': 'en pt', 'ek': 'en ko', 'ej': 'en ja'}
	if langpairs.has_key(stsp[0]):
		pair=langpairs[stsp[0]]
		pair=string.split(pair, ' ', 1)
		answ = google_translate(pair[0],pair[1],stsp[1].encode('utf-8'))
		answ=answ.replace('&apos;', '\\').replace('&gt;', '>').replace('&lt;', '<').replace('<br>', '\n').replace('&quot;', '"').replace('&#39;', '\'')
		reply(type,source,unicode(answ))
	else:
		reply(type,source,u'что это за язык?')

def handler_google_trans_autolang(type,source,parameters):
	if parameters == '':
		reply(type,source, u'И что ты хочешь этим сказать?')
		return
	par=parameters.strip()
	rus = [u'а', u'б', u'в', u'г', u'д', u'е', u'ё', u'ж', u'з', u'и', u'й', u'к', u'л', u'м', u'н', u'о', u'п', u'р', u'с', u'т', u'у', u'ф', u'х', u'ц', u'ч', u'ш', u'щ', u'ъ', u'ь', u'ы', u'э', u'ю', u'я']
	eng = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']
	k = 0
	i = 0
	lang = 'not'
	while (k != 1):
		if (par[i] in rus):
			lang = 're'
			k = 1
		else:
			if (par[i] in eng):
				lang = 'er'
				k = 1
			else:
				i += 1
				if (i == len(par)-1):
					k = 1
	if lang == 'not':
		reply(type,source, u'Невозможно определить язык!')
		return
	parameters = lang + ' ' + parameters
	stsp=string.split(parameters, ' ', 1)
	langpairs={'er': 'en ru', 're': 'ru en','ef': 'en fr','ed': 'en de', 'df': 'de fr','ei': 'en it', 'es': 'en sp', 'ep': 'en pt', 'ek': 'en ko', 'ej': 'en ja'}
	if langpairs.has_key(stsp[0]):
		pair=langpairs[stsp[0]]
		pair=string.split(pair, ' ', 1)
		answ = google_translate(pair[0],pair[1],stsp[1].encode('utf-8'))
		answ=answ.replace('&apos;', '\\').replace('&gt;', '>').replace('&lt;', '<').replace('<br>', '\n').replace('&quot;', '"').replace('&#39;', '\'')
		reply(type,source,unicode(answ))
	else:
		reply(type,source,u'что это за язык?')
		

register_command_handler(handler_google_trans, 'перевод', ['инфо','все'], 10, 'Переводит фразу на одном языке в другой. Подробнее - напишите "перевод языки".', 'перевод <исходный_язык> <нужный_язык> <фраза>', ['перевод er hello', 'перевод re привет'])
register_command_handler(handler_google_trans_autolang, '!', ['инфо','все', 'new'], 10, 'Переводит фразу с английского в русский и наоборот, с автоматическим определением направления перевода.\nНаписал: Gigabyte (С)\nИдея: Терракот', '! <фраза>', ['! hello', '! привет'])
